'use strict';

var exec = require('child_process').exec;

module.exports.getCurrentUsageByPid = function (pid, cb) {
	exec('ps -p ' + pid + ' -o rss,vsz', function (error, out) {
		if (error) {
			return cb(error);
		}
		var list = out.split('\n');
		/*
		output string is always:
		RSS	VSZ
		xxxx	yyyyy
		*/
		var keys = list[0].split(' ').filter(function (item) {
			return item !== '';
		});
		var values = list[1].split(' ').filter(function (item) {
			return item !== '';
		});
		var res = {};
		for (var i = 0, len = keys.length; i < len; i++) {
			res[keys[i]] = values[i];
		}
		cb(null, res);
	});
};

module.exports.getCurrentUsageByPids = function (plist, cb) {
	var res = {};
	var index = 0;
	var run = function () {
		var pid = plist[index];
		module.exports.getCurrentUsageByPid(pid, function (error, mem) {
			if (error) {
				return cb(error);
			}
			res[pid] = mem;
			index += 1;
			if (plist[index]) {
				return run();
			}
			cb(null, res);
		});
	};
	run();
};
